<?php
/**
* © Copyright 2011 IntraHealth International, Inc.
* 
* This File is part of I2CE 
* 
* I2CE is free software; you can redistribute it and/or modify 
* it under the terms of the GNU General Public License as published by 
* the Free Software Foundation; either version 3 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful, 
* but WITHOUT ANY WARRANTY; without even the implied warranty of 
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
* GNU General Public License for more details.
* 
* You should have received a copy of the GNU General Public License 
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
* @package ihris-retain
* @subpackage retain
* @author Carl Leitner <litlfred@ibiblio.org>
* @version v1.1
* @since v1.1
* @filesource 
*/ 
/** 
* Class iHRIS_Finanical
* 
* @access public
*/


class iHRIS_Financial extends iHRIS_Yearly{
    /**
     * Get the field names that are yearly inputs
     * @returns array of string
     */ 
    public function yearlyInputs() {
        return  array('total_budget','total_recurrent_budget','total_personnel_budget','donor_contribution','exchange_USD','inflation');
    }

}
# Local Variables:
# mode: php
# c-default-style: "bsd"
# indent-tabs-mode: nil
# c-basic-offset: 4
# End:
