var I2CE_DuplicitiveForm = new Class({
    Implements: [Options],
    source: null,
    target:null,
    button:null,
    rembutton:null,
    drag: null,
    add_where:'before', //http://mootools.net/docs/core/Element/Element#Element:inject
    options: {
	link_id:'list_fields',
	add_location_id:'add_content',
	add_after_id:'add_content',
	add_button_id:'add_another',
	remove_button_id:'remove_another',
	always_one:true,
	post:false	
    },

    cloneSource: function() {
	return this.cloneWithEvents(this.source);
    },

    isAnonymous: function(item,index) {
	var isAnon = false;
	item.getElements('textarea, select, input').each(
	    function (node) {		
		var name = node.get('name');			
		//forms:othercost:10399:fields (not anonymous)
		//or forms:othercost:0:0:fields  (anonymous)
		//or forms:othercost:0:1:fields ... etc (anonymous)
		name.split('[').each(
		    function (piece,index) {
			if (piece.length > 1 && piece.charAt(piece.length-1) == ']') {
			    piece = piece.substr(0,piece.length -1);
			}
			if (index == 2 && piece == '0') {
			    isAnon = true;
			}
		    }

		);
	    }
	);
	return isAnon;
    },
	
    initialize: function(options ) {
	var clicker;
	var remclicker;
	this.setOptions(options);	
	this.button = $(this.options.add_button_id);
	this.rembutton = $(this.options.remove_button_id);
	this.target = $(this.options.add_location_id);
	this.source= $(this.options.link_id);
	if (this.source) {
	    this.source.getElements(".duplicate_counter").each(
		function (label) {
		    label.set('html','# 1');
		});
	    this.source = this.source.clone();
	}
	if (this.source && this.target) {
	    if ( this.button) {
		clicker = function(event) {
		    var cloned, inputs;
		    var elems = $$( '*[id=' + this.options.link_id + ']');
		    var anon_elems = elems.filter(this.isAnonymous);		    
		    cloned = this.source.clone();
		    cloned.getElements(".duplicate_counter").each(
			function (label) {
			    var which =  anon_elems.length + 1;
			    label.set('html','# '  + which);
			});
		    cloned.set('id',this.options.link_id);
		    cloned.getElements('textarea, select, input').each(
			function (node) {
			    var name = node.get('name');			
			    var counter = $$( '*[id=' + this.options.link_id + ']').length;			   
			    var new_name = [];
			    //forms:othercost:10399:fields (not anonymous)
			    //or forms:othercost:0:0:fields  (anonymous)
			    //or forms:othercost:0:1:fields ... etc (anonymous)
			    var is_anon =0;
			    name.split('[').each(function (piece,index) {
				if (piece.length > 1 && piece.charAt(piece.length-1) == ']') {
				    piece = piece.substr(0,piece.length -1);
				}
				if (index <= 1) {
				    new_name[index] = piece;
				    return;
				}else if (index == 2) {
				    if (piece == '0') {
					is_anon = 1;
				    }
				    new_name[2] = 0;  
				    new_name[3] = counter;
				} else  {
				    if (is_anon) {
					if (index > 3) {
					    new_name[index] = piece;
					}
				    } else {
					if (index > 2) {
					    new_name[index + 1] = piece;
					}
				    }
				}
			    });
			    if (new_name.length > 1) {
				new_name = new_name[0]  + '[' + new_name.slice(1,new_name.length ).join('][') + ']';
			    } else {
				new_name = new_name[0];
			    }
			    node.setProperty('name',new_name);
			},this);
		    this.counter++;
		    cloned.inject(this.target, this.add_where);		
		    if (this.options.post) {			
			this.options.post(cloned);
		    }
		    if (PageStretch) {
			PageStretch.stretchPage();
		    }
		    if (this.rembutton) {
			this.rembutton.setStyle('display','inline');
		    }
		}.bind(this).bindWithEvent(this);
		this.button.addEvent('click',clicker);	
	    }
	    if ( this.rembutton) {
		remclicker = function(event) {
		    var elems = $$( '*[id=' + this.options.link_id + ']').filter(this.isAnonymous);
		    if (elems.length == 1) {
			if (this.options.always_one) {
			    return;
			} else {
			    this.rembutton.setStyle('display','none');
			}
		    }
		    if ((elems.length == 1 && !this.options.always_one) || elems.length  > 1) {
			elems.getLast().destroy();
		    }
		}.bind(this).bindWithEvent(this);
		this.rembutton.addEvent('click',remclicker);	
	    }
	    
	}
    }

});